package F5::ProtocolBuffers;

use strict;
use warnings;

use Google::ProtocolBuffers::Dynamic;
use File::Find;
use File::Basename;
use File::Spec;

#----------------------------------------------------------------------

sub init {
    my(%params) = @_;
    my $base_dir = $params{base_dir};
    my $package = $params{package};

    my $p = Google::ProtocolBuffers::Dynamic->new($base_dir);
    my $was_protobuf_file_found = 0;
    find({
          no_chdir => 1,
          wanted => sub {
              my $filename = basename($File::Find::name);
              if (-f $File::Find::name && $filename =~ /\.proto$/) {
                  my $relative_path = File::Spec->abs2rel($File::Find::name, $base_dir);
                  $p->load_file($relative_path);
                  $was_protobuf_file_found = 1;
              }
          },
         },
         $base_dir);

    if ($was_protobuf_file_found) {
        $p->map({package => "google.protobuf", prefix => "google.protobuf"},
                {package => $package, prefix => $package});
    }

    return $was_protobuf_file_found;
}

#----------------------------------------------------------------------

1;
